Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Help/Bootmenu_RomBoot.txt
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Help/Bootmenu_RomBoot.txt	(revision 108)
+++ 	(revision )
@@ -1,1 +1,0 @@
-Some old systems have BASIC or DOS in ROM. Since most systems don't have either, ROM Boot setting is disabled by default. Enable it if you have use for it.
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Variables.inc
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Variables.inc	(revision 108)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Variables.inc	(revision 109)
@@ -1,7 +1,3 @@
-; File name		:	Variables.inc
 ; Project name	:	XTIDE Univeral BIOS Configurator v2
-; Created date	:	5.10.2010
-; Last update	:	6.12.2010
-; Author		:	Tomi Tilli
 ; Description	:	Global variables for configuration program.
 %ifndef VARIABLES_INC
@@ -9,5 +5,5 @@
 
 ; Equates and defines
-MAX_ALLOWED_IDE_CONTROLLERS			EQU		5	; Maximum number of IDE controllers
+MAX_ALLOWED_IDE_CONTROLLERS			EQU		4	; Maximum number of IDE controllers
 EEPROM_POLLING_TIMEOUT_TICKS		EQU		3	; 1 tick = 54.9 ms
 XTIDE_SIGNATURE_LENGTH				EQU		8	; XTIDE Universal BIOS signature string length
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm	(revision 108)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm	(revision 109)
@@ -1,7 +1,3 @@
-; File name		:	Buffers.asm
 ; Project name	:	XTIDE Universal BIOS Configurator v2
-; Created date	:	6.10.2010
-; Last update	:	6.12.2010
-; Author		:	Tomi Tilli
 ; Description	:	Functions for accessing file and flash buffers.
 
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Dialogs.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Dialogs.asm	(revision 108)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Dialogs.asm	(revision 109)
@@ -173,5 +173,5 @@
 .InitializeProgressDialogIoInDSSIwithFlashvarsInDSBX:
 	call	InitializeDialogInputFromDSSI
-	mov		WORD [si+DIALOG_INPUT.fszTitle], g_szEEPROM
+	mov		WORD [si+DIALOG_INPUT.fszTitle], g_szFlashTitle
 
 	xor		ax, ax
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Main.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Main.asm	(revision 108)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Main.asm	(revision 109)
@@ -1,7 +1,3 @@
-; File name		:	main.asm
 ; Project name	:	XTIDE Univeral BIOS Configurator v2
-; Created date	:	5.10.2010
-; Last update	:	7.12.2010
-; Author		:	Tomi Tilli
 ; Description	:	Program start and exit.			
 
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/MenuEvents.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/MenuEvents.asm	(revision 108)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/MenuEvents.asm	(revision 109)
@@ -1,7 +1,3 @@
-; File name		:	MenuEvents.asm
 ; Project name	:	XTIDE Universal BIOS Configurator v2
-; Created date	:	5.10.2010
-; Last update	:	30.11.2010
-; Author		:	Tomi Tilli
 ; Description	:	Menu event handling.
 
@@ -79,4 +75,5 @@
 	CALL_DISPLAY_LIBRARY GetColumnsToALandRowsToAH
 	mov		[si+MENUINIT.bHeight], ah
+	call	MainMenu_EnterMenuOrModifyItemVisibility
 	stc
 	ret
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupage.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupage.asm	(revision 108)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupage.asm	(revision 109)
@@ -1,7 +1,3 @@
-; File name		:	Menupage.asm
 ; Project name	:	XTIDE Universal BIOS Configurator v2
-; Created date	:	5.10.2010
-; Last update	:	1.11.2010
-; Author		:	Tomi Tilli
 ; Description	:	Functions for accessing MENUPAGE structs.
 
@@ -32,5 +28,5 @@
 
 ;--------------------------------------------------------------------
-; Menupage_SetActiveMenupageFromDSDI
+; SetActiveMenupageFromDSDI
 ;	Parameters:
 ;		DS:DI:	Ptr to MENUPAGE to set active
@@ -39,5 +35,5 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, DI
+;		Nothing
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/BootMenuSettingsMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/BootMenuSettingsMenu.asm	(revision 108)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/BootMenuSettingsMenu.asm	(revision 109)
@@ -36,20 +36,4 @@
 	at	MENUITEM.itemValue + ITEM_VALUE.wMinValue,					dw	0
 	at	MENUITEM.itemValue + ITEM_VALUE.wMaxValue,					dw	0FFh
-iend
-
-g_MenuitemBootMnuStngsDisplayRomBoot:
-istruc MENUITEM
-	at	MENUITEM.fnActivate,		dw	Menuitem_ActivateMultichoiceSelectionForMenuitemInDSSI
-	at	MENUITEM.fnFormatValue,		dw	MenuitemPrint_WriteLookupValueStringToBufferInESDIfromShiftedItemInDSSI
-	at	MENUITEM.szName,			dw	g_szItemBootRomBoot
-	at	MENUITEM.szQuickInfo,		dw	g_szNfoBootRomBoot
-	at	MENUITEM.szHelp,			dw	g_szHelpBootRomBoot
-	at	MENUITEM.bFlags,			db	FLG_MENUITEM_VISIBLE | FLG_MENUITEM_FLAGVALUE
-	at	MENUITEM.bType,				db	TYPE_MENUITEM_MULTICHOICE
-	at	MENUITEM.itemValue + ITEM_VALUE.wRomvarsValueOffset,		dw	ROMVARS.wFlags
-	at	MENUITEM.itemValue + ITEM_VALUE.szDialogTitle,				dw	g_szDlgBootRomBoot
-	at	MENUITEM.itemValue + ITEM_VALUE.szMultichoice,				dw	g_szMultichoiceBooleanFlag
-	at	MENUITEM.itemValue + ITEM_VALUE.rgszValueToStringLookup,	dw	g_rgszValueToStringLookupForFlagBooleans
-	at	MENUITEM.itemValue + ITEM_VALUE.wValueBitmask,				dw	FLG_ROMVARS_ROMBOOT
 iend
 
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/ConfigurationMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/ConfigurationMenu.asm	(revision 108)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/ConfigurationMenu.asm	(revision 109)
@@ -63,14 +63,4 @@
 iend
 
-g_MenuitemConfigurationQuinaryIdeController:
-istruc MENUITEM
-	at	MENUITEM.fnActivate,		dw	QuinaryIdeController
-	at	MENUITEM.szName,			dw	g_szItemCfgIde5
-	at	MENUITEM.szQuickInfo,		dw	g_szNfoCfgIde
-	at	MENUITEM.szHelp,			dw	g_szNfoCfgIde
-	at	MENUITEM.bFlags,			db	NULL
-	at	MENUITEM.bType,				db	TYPE_MENUITEM_PAGENEXT
-iend
-
 g_MenuitemConfigurationBootMenuSettings:
 istruc MENUITEM
@@ -79,22 +69,6 @@
 	at	MENUITEM.szQuickInfo,		dw	g_szNfoCfgBootMenu
 	at	MENUITEM.szHelp,			dw	g_szNfoCfgBootMenu
-	at	MENUITEM.bFlags,			db	NULL
-	at	MENUITEM.bType,				db	TYPE_MENUITEM_PAGENEXT
-iend
-
-g_MenuitemConfigurationBootLoaderType:
-istruc MENUITEM
-	at	MENUITEM.fnActivate,		dw	Menuitem_ActivateMultichoiceSelectionForMenuitemInDSSI
-	at	MENUITEM.fnFormatValue,		dw	MenuitemPrint_WriteLookupValueStringToBufferInESDIfromShiftedItemInDSSI
-	at	MENUITEM.szName,			dw	g_szItemCfgBootLoader
-	at	MENUITEM.szQuickInfo,		dw	g_szNfoCfgBootLoader
-	at	MENUITEM.szHelp,			dw	g_szNfoCfgBootLoader
-	at	MENUITEM.bFlags,			db	FLG_MENUITEM_VISIBLE | FLG_MENUITEM_MODIFY_MENU | FLG_MENUITEM_BYTEVALUE
-	at	MENUITEM.bType,				db	TYPE_MENUITEM_MULTICHOICE
-	at	MENUITEM.itemValue + ITEM_VALUE.wRomvarsValueOffset,		dw	ROMVARS.bBootLdrType
-	at	MENUITEM.itemValue + ITEM_VALUE.szDialogTitle,				dw	g_szItemCfgBootLoader
-	at	MENUITEM.itemValue + ITEM_VALUE.szMultichoice,				dw	g_szMultichoiceCfgBootLoader
-	at	MENUITEM.itemValue + ITEM_VALUE.rgwChoiceToValueLookup,		dw	g_rgwChoiceToValueLookupForBootLoaderType
-	at	MENUITEM.itemValue + ITEM_VALUE.rgszValueToStringLookup,	dw	g_rgszValueToStringLookupForBootLoaderType
+	at	MENUITEM.bFlags,			db	FLG_MENUITEM_VISIBLE
+	at	MENUITEM.bType,				db	TYPE_MENUITEM_PAGENEXT
 iend
 
@@ -142,17 +116,6 @@
 	at	MENUITEM.itemValue + ITEM_VALUE.szDialogTitle,				dw	g_szDlgCfgIdeCnt
 	at	MENUITEM.itemValue + ITEM_VALUE.wMinValue,					dw	1
-	at	MENUITEM.itemValue + ITEM_VALUE.wMaxValue,					dw	5
-iend
-
-
-g_rgwChoiceToValueLookupForBootLoaderType:
-	dw	BOOTLOADER_TYPE_MENU
-	dw	BOOTLOADER_TYPE_SIMPLE
-	dw	BOOTLOADER_TYPE_NONE
-g_rgszValueToStringLookupForBootLoaderType:
-	dw	g_szValueCfgBootLoaderMenu
-	dw	g_szValueCfgBootLoaderAthenC
-	dw	g_szUnidentified
-	dw	g_szValueCfgBootLoaderSystem
+	at	MENUITEM.itemValue + ITEM_VALUE.wMaxValue,					dw	4
+iend
 
 
@@ -175,5 +138,4 @@
 	call	.DisableAllIdeControllerMenuitems
 	call	.EnableIdeControllerMenuitemsBasedOnConfiguration
-	call	.EnableOrDisableBootMenuSettings
 	call	.EnableOrDisableKiBtoStealFromRAM
 	call	.EnableOrDisableIdeControllerCount
@@ -239,24 +201,4 @@
 	mov		cx, 1
 	ret
-
-
-;--------------------------------------------------------------------
-; .EnableOrDisableBootMenuSettings
-;	Parameters:
-;		SS:BP:	Menu handle
-;	Returns:
-;		Nothing
-;	Corrupts registers:
-;		AX, BX, CX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-.EnableOrDisableBootMenuSettings:
-	mov		bx, ROMVARS.bBootLdrType
-	call	Buffers_GetRomvarsValueToAXfromOffsetInBX
-	mov		bx, g_MenuitemConfigurationBootMenuSettings
-	cmp		ax, BYTE BOOTLOADER_TYPE_MENU
-	jne		SHORT .DisableMenuitemFromCSBX
-	jmp		SHORT .EnableMenuitemFromCSBX
-
 
 ;--------------------------------------------------------------------
@@ -291,6 +233,9 @@
 	mov		bx, g_MenuitemConfigurationIdeControllers
 	test	ax, FLG_ROMVARS_FULLMODE
-	jz		SHORT .DisableMenuitemFromCSBX
-	jmp		SHORT .EnableMenuitemFromCSBX
+	jnz		SHORT .EnableMenuitemFromCSBX
+.LimitIdeControllerCountToOneForLiteMode:
+	call	Buffers_GetFileBufferToESDI
+	mov		BYTE [es:di+ROMVARS.bIdeCnt], 1
+	jmp		SHORT .DisableMenuitemFromCSBX
 
 ;--------------------------------------------------------------------
@@ -343,9 +288,4 @@
 QuaternaryIdeController:
 	mov		bx, ROMVARS.ideVars3
-	jmp		SHORT DisplayIdeControllerMenu
-
-ALIGN JUMP_ALIGN
-QuinaryIdeController:
-	mov		bx, ROMVARS.ideVars4
 	; Fall to DisplayIdeControllerMenu
 
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/IdeControllerMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/IdeControllerMenu.asm	(revision 108)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/IdeControllerMenu.asm	(revision 109)
@@ -198,5 +198,5 @@
 	call	Buffers_GetRomvarsValueToAXfromOffsetInBX
 	mov		bx, g_MenuitemIdeControllerIdeIRQ
-	test	ax, ax
+	test	al, al
 	jz		SHORT .DisableMenuitemFromCSBX
 	; Fall to .EnableMenuitemFromCSBX
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 108)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 109)
@@ -7,6 +7,6 @@
 ; Menu title
 g_szProgramTitle:
-	db	"Configuration and Flashing program for XTIDE Universal BIOS v1.1.5.",LF,CR,NULL
-g_szXtideUniversalBiosSignature:	db	"XTIDE110",NULL
+	db	"Configuration and Flashing program for XTIDE Universal BIOS v1.2.0.",LF,CR,NULL
+g_szXtideUniversalBiosSignature:	db	"XTIDE120",NULL
 g_szBiosIsNotLoaded:				db	"BIOS is not loaded!",NULL
 g_szEEPROM:							db	"EEPROM",NULL
@@ -38,4 +38,5 @@
 
 ; Flashing related strings
+g_szFlashTitle:			db	"Flashing EEPROM, please wait.",NULL
 g_szErrEepromTooSmall:	db	"Image is too large for selected EEPROM type!",NULL
 g_szErrEepromPolling:	db	"Timeout when polling EEPROM.",LF
@@ -80,7 +81,5 @@
 g_szItemCfgIde3:		db	"Tertiary IDE Controller",NULL
 g_szItemCfgIde4:		db	"Quaternary IDE Controller",NULL
-g_szItemCfgIde5:		db	"Quinary IDE Controller",NULL
 g_szItemCfgBootMenu:	db	"Boot menu settings",NULL
-g_szItemCfgBootLoader:	db	"Boot loader type",NULL
 g_szItemCfgFullMode:	db	"Full operating mode",NULL
 g_szItemCfgStealSize:	db	"kiB to steal from RAM",NULL
@@ -93,5 +92,4 @@
 g_szNfoCfgIde:			db	"IDE controller and drive configuration.",NULL
 g_szNfoCfgBootMenu:		db	"Boot menu configuration.",NULL
-g_szNfoCfgBootLoader:	db	"Boot loader selection for INT 19h.",NULL
 g_szNfoCfgFullMode:		db	"Full mode supports multiple controllers and has more features.",NULL
 g_szNfoCfgStealSize:	db	"How many kiB's to steal from Conventional memory for XTIDE Universal BIOS variables.",NULL
@@ -102,13 +100,4 @@
 g_szHelpCfgStealSize:	incbin	"Configuration_StealSize.txt"
 						db	NULL
-
-g_szMultichoiceCfgBootLoader:
-						db	"Boot menu",LF
-						db	"Drive A then C",LF
-						db	"System boot loader",NULL
-
-g_szValueCfgBootLoaderMenu:		db	"Menu",NULL
-g_szValueCfgBootLoaderAthenC:	db	"A, C",NULL
-g_szValueCfgBootLoaderSystem:	db	"System",NULL
 
 
@@ -190,5 +179,4 @@
 g_szItemBootFloppyDrvs:	db	"Number of Floppy Drives",NULL
 g_szItemBootSwap:		db	"Swap boot drive numbers",NULL
-g_szItemBootRomBoot:	db	"Display ROM boot",NULL
 
 g_szDlgBootTimeout:		db	"Enter Boot Menu selection timeout in seconds (1...60, 0 disables timeout).",NULL
@@ -196,5 +184,4 @@
 g_szDlgBootFloppyDrvs:	db	"Enter number of Floppy Drives to display on boot menu.",NULL
 g_szDlgBootSwap:		db	"Enable drive number translation?",NULL
-g_szDlgBootRomBoot:		db	"Show ROM Boot option on boot menu?",NULL
 
 g_szNfoBootTimeout:		db	"Menu item selection timeout in seconds.",NULL
@@ -202,5 +189,4 @@
 g_szNfoBootFloppyDrvs:	db	"Number of Floppy Drives to display on boot menu.",NULL
 g_szNfoBootSwap:		db	"Drive Number Translation (swap first drive with selected).",NULL
-g_szNfoBootRomBoot:		db	"Show ROM Basic or ROM DOS boot option.",NULL
 
 g_szHelpBootTimeout:	incbin	"Bootmenu_Timeout.txt"
@@ -211,6 +197,4 @@
 						db	NULL
 g_szHelpBootSwap:		incbin	"Bootmenu_SwapDrives.txt"
-						db	NULL
-g_szHelpBootRomBoot:	incbin	"Bootmenu_RomBoot.txt"
 						db	NULL
 