Index: trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenu.asm	(revision 128)
+++ trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenu.asm	(revision 130)
@@ -24,8 +24,8 @@
 	cmp		cx, BYTE NO_ITEM_SELECTED
 	je		SHORT BootMenu_DisplayAndReturnSelection	; Clear screen and display menu
-	; Fall through to BootMenu_ConvertMenuitemFromCXtoDriveInDX
+	; Fall to BootMenu_GetDriveToDXforMenuitemInCX
 
 ;--------------------------------------------------------------------
-; BootMenu_ConvertMenuitemFromCXtoDriveInDX
+; BootMenu_GetDriveToDXforMenuitemInCX
 ;	Parameters:
 ;		CX:		Index of menuitem selected from Boot Menu
@@ -37,5 +37,5 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-BootMenu_ConvertMenuitemFromCXtoDriveInDX:
+BootMenu_GetDriveToDXforMenuitemInCX:
 	mov		dx, cx					; Copy menuitem index to DX
 	call	FloppyDrive_GetCountToCX
@@ -107,19 +107,20 @@
 
 ;--------------------------------------------------------------------
-; BootMenu_ConvertAsciiHotkeyFromALtoMenuitemInCX
+; BootMenu_GetMenuitemToAXforAsciiHotkeyInAL
 ;	Parameters:
-;		AL:		ASCII hotkey starting from upper case 'A'
+;		AL:		ASCII hotkey
 ;	Returns:
-;		CX:		Menuitem index
+;		AX:		Menuitem index
 ;	Corrupts registers:
-;		AX
+;		CX
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-BootMenu_ConvertAsciiHotkeyFromALtoMenuitemInCX:
+BootMenu_GetMenuitemToAXforAsciiHotkeyInAL:
+	call	Char_ALtoUpperCaseLetter
 	call	BootMenu_GetLetterForFirstHardDiskToCL
+	xor		ah, ah
 	cmp		al, cl						; Letter is for Hard Disk?
 	jae		SHORT .StartFromHardDiskLetter
 	sub		al, 'A'						; Letter to Floppy Drive menuitem
-	xchg	ax, cx						; Menuitem index to CX
 	ret
 ALIGN JUMP_ALIGN
@@ -127,5 +128,5 @@
 	sub		al, cl						; Hard Disk index
 	call	FloppyDrive_GetCountToCX
-	add		cx, ax						; Menuitem index
+	add		ax, cx						; Menuitem index
 	ret
 
@@ -188,9 +189,9 @@
 BootMenu_IsDriveInSystem:
 	test	dl, dl								; Floppy drive?
-	jns		SHORT .IsFloppyDriveIsInSystem
+	jns		SHORT .IsFloppyDriveInSystem
 	call	RamVars_GetHardDiskCountFromBDAtoCX	; Hard Disk count to CX
 	or		cl, 80h								; Set Hard Disk bit to CX
 	jmp		SHORT .CompareDriveNumberToDriveCount
-.IsFloppyDriveIsInSystem:
+.IsFloppyDriveInSystem:
 	call	FloppyDrive_GetCountToCX
 .CompareDriveNumberToDriveCount:
Index: trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuEvent.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuEvent.asm	(revision 128)
+++ trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuEvent.asm	(revision 130)
@@ -86,5 +86,5 @@
 	call	RamVars_GetSegmentToDS
 	call	DriveXlate_Reset
-	call	BootMenu_ConvertMenuitemFromCXtoDriveInDX
+	call	BootMenu_GetDriveToDXforMenuitemInCX
 	call	DriveXlate_SetDriveToSwap
 	pop		ax		; Update previous item
@@ -107,8 +107,7 @@
 ALIGN JUMP_ALIGN
 .CheckDriveHotkeys:
-	call	BootMenu_ConvertAsciiHotkeyFromALtoMenuitemInCX
-	cmp		cx, [bp+MENUINIT.wItems]
+	call	BootMenu_GetMenuitemToAXforAsciiHotkeyInAL
+	cmp		ax, [bp+MENUINIT.wItems]
 	jae		SHORT .EventCompleted	; Invalid key
-	xchg	ax, cx
 	CALL_MENU_LIBRARY HighlightItemFromAX
 	; Fall to .ItemSelectedFromCX
@@ -150,5 +149,4 @@
 ;		CF:		set since event processed
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
 .RefreshItemOrInformationWithJumpTableInCSBX:
 	cmp		cl, NO_ITEM_HIGHLIGHTED
@@ -156,5 +154,5 @@
 
 	call	RamVars_GetSegmentToDS
-	call	BootMenu_ConvertMenuitemFromCXtoDriveInDX
+	call	BootMenu_GetDriveToDXforMenuitemInCX
 	test	dl, dl					; Floppy drive?
 	jns		SHORT .DrawFloppyDrive
Index: trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrint.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrint.asm	(revision 128)
+++ trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrint.asm	(revision 130)
@@ -4,4 +4,38 @@
 ; Section containing code
 SECTION .text
+
+;--------------------------------------------------------------------
+; BootMenuPrint_ClearScreen
+;	Parameters:
+;		Nothing
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, DI
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+BootMenuPrint_ClearScreen:
+	call	BootMenuPrint_InitializeDisplayContext
+	xor		ax, ax
+	CALL_DISPLAY_LIBRARY SetCursorCoordinatesFromAX
+	mov		ax, ' ' | (MONO_NORMAL<<8)
+	CALL_DISPLAY_LIBRARY ClearScreenWithCharInALandAttrInAH
+	ret
+
+
+;--------------------------------------------------------------------
+; BootMenuPrint_InitializeDisplayContext
+;	Parameters:
+;		Nothing
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, DI
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+BootMenuPrint_InitializeDisplayContext:
+	CALL_DISPLAY_LIBRARY InitializeDisplayContext
+	ret
+
 
 ;--------------------------------------------------------------------
@@ -40,20 +74,4 @@
 	pop		di
 	stc
-	ret
-
-
-;--------------------------------------------------------------------
-; BootMenuPrint_ClearScreen
-;	Parameters:
-;		Nothing
-;	Returns:
-;		Nothing
-;	Corrupts registers:
-;		AX, DI
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenuPrint_ClearScreen:
-	mov		ax, ' ' | (MONO_NORMAL<<8)
-	CALL_DISPLAY_LIBRARY ClearScreenWithCharInALandAttrInAH
 	ret
 
Index: trunk/XTIDE_Universal_BIOS/Src/Boot/BootPrint.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Boot/BootPrint.asm	(revision 128)
+++ trunk/XTIDE_Universal_BIOS/Src/Boot/BootPrint.asm	(revision 130)
@@ -37,18 +37,18 @@
 
 ;--------------------------------------------------------------------
-; BootPrint_BootSectorResultStringFromBX
+; BootPrint_BootSectorResultStringFromAX
 ;	Parameters:
-;		CS:BX:	Ptr to "found" or "not found"
+;		CS:AX:	Ptr to "found" or "not found"
 ;	Returns:
 ;		Nothing
 ;	Corrupts registers:
-;		AX, SI, DI
+;		AX, CX, SI, DI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-BootPrint_BootSectorResultStringFromBX:
+BootPrint_BootSectorResultStringFromAX:
 	push	bp
 	mov		bp, sp
-	ePUSH_T	ax, g_szBootSector
-	push	bx			; "found" or "not found"
+	ePUSH_T	cx, g_szBootSector
+	push	ax			; "found" or "not found"
 	mov		si, g_szSectRead
 	jmp		BootMenuPrint_FormatCSSIfromParamsInSSBP
@@ -62,5 +62,5 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, BX, SI, DI
+;		AX, CX, SI, DI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -68,6 +68,6 @@
 	push	bp
 	mov		bp, sp
-	eMOVZX	bx, ah
-	push	bx					; Push INT 13h error code
+	eMOVZX	cx, ah
+	push	cx					; Push INT 13h error code
 	mov		si, g_szReadError
 	jmp		BootMenuPrint_FormatCSSIfromParamsInSSBP
Index: trunk/XTIDE_Universal_BIOS/Src/Boot/BootSector.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Boot/BootSector.asm	(revision 128)
+++ trunk/XTIDE_Universal_BIOS/Src/Boot/BootSector.asm	(revision 130)
@@ -28,6 +28,6 @@
 	jne		SHORT .FirstHardDiskSectorNotBootable
 .AlwaysBootFromFloppyDriveForBooterGames:
-	mov		bx, g_szFound
-	call	BootPrint_BootSectorResultStringFromBX
+	mov		ax, g_szFound
+	call	BootPrint_BootSectorResultStringFromAX
 	stc
 	ret
@@ -37,6 +37,6 @@
 	ret
 .FirstHardDiskSectorNotBootable:
-	mov		bx, g_szNotFound
-	call	BootPrint_BootSectorResultStringFromBX
+	mov		ax, g_szNotFound
+	call	BootPrint_BootSectorResultStringFromAX
 	clc
 	ret
@@ -66,5 +66,4 @@
 	dec		di								; Decrement retry counter
 	jnz		SHORT .ReadRetryLoop			; Loop while retries left
-ALIGN JUMP_ALIGN
 .Return:
 	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int19hMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int19hMenu.asm	(revision 128)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int19hMenu.asm	(revision 130)
@@ -20,5 +20,5 @@
 	STORE_POST_STACK_POINTER
 	SWITCH_TO_BOOT_MENU_STACK
-	CALL_DISPLAY_LIBRARY InitializeDisplayContext
+	call	BootMenuPrint_InitializeDisplayContext
 	call	RamVars_GetSegmentToDS
 	; Fall to .ProcessMenuSelectionsUntilBootable
@@ -34,5 +34,5 @@
 .ProcessMenuSelectionsUntilBootable:
 	call	BootMenu_DisplayAndReturnSelection
-	call	DriveXlate_ToOrBack			; Translate drive number
+	call	DriveXlate_ToOrBack							; Translate drive number
 	call	BootSector_TryToLoadFromDriveDL
 	jnc		SHORT .ProcessMenuSelectionsUntilBootable	; Boot failure, show menu again
Index: trunk/XTIDE_Universal_BIOS/Src/Initialization/Initialize.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Initialization/Initialize.asm	(revision 128)
+++ trunk/XTIDE_Universal_BIOS/Src/Initialization/Initialize.asm	(revision 130)
@@ -70,5 +70,5 @@
 ;--------------------------------------------------------------------
 Initialize_AndDetectDrives:
-	CALL_DISPLAY_LIBRARY InitializeDisplayContext
+	call	BootMenuPrint_InitializeDisplayContext
 	call	DetectPrint_RomFoundAtSegment
 	call	RamVars_Initialize
Index: trunk/XTIDE_Universal_BIOS/Src/Strings.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Strings.asm	(revision 128)
+++ trunk/XTIDE_Universal_BIOS/Src/Strings.asm	(revision 130)
@@ -34,7 +34,7 @@
 g_szCapacity:	db	"Capacity : ",NULL
 g_szSizeSingle:	db	"%s%u.%u %ciB",NULL
-g_szSizeDual:	db	"%s%u.%u %ciB / %u.%u %ciB",LF,CR,NULL
+g_szSizeDual:	db	"%s%4-u.%u %ciB / %4-u.%u %ciB",LF,CR,NULL
 g_szCfgHeader:	db	"Addr.",SINGLE_VERTICAL,"Block",SINGLE_VERTICAL,"Bus",  SINGLE_VERTICAL,"IRQ",  SINGLE_VERTICAL,"Reset",LF,CR,NULL
-g_szCfgFormat:	db	"%s"   ,SINGLE_VERTICAL,"%5u",  SINGLE_VERTICAL,"%c%2u",SINGLE_VERTICAL," %c%c",SINGLE_VERTICAL,"%5x",  NULL
+g_szCfgFormat:	db	"%s"   ,SINGLE_VERTICAL,"%5-u",  SINGLE_VERTICAL,"%c%2u",SINGLE_VERTICAL," %c%c",SINGLE_VERTICAL,"%5-x",  NULL
 g_szLCHS:		db	"L-CHS",NULL
 g_szPCHS:		db	"P-CHS",NULL