Index: trunk/Assembly_Library/Src/AssemblyLibrary.asm
===================================================================
--- trunk/Assembly_Library/Src/AssemblyLibrary.asm	(revision 129)
+++ trunk/Assembly_Library/Src/AssemblyLibrary.asm	(revision 131)
@@ -58,5 +58,7 @@
 %ifdef INCLUDE_STRING_LIBRARY
 	%include "Char.asm"
-	%include "String.asm"
+	%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+		%include "String.asm"
+	%endif
 	%include "StringProcess.asm"
 %endif
@@ -68,5 +70,5 @@
 
 %ifdef INCLUDE_UTIL_LIBRARY
-	%ifndef EXCLUDE_BIT_UTILS
+	%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 		%include "Bit.asm"
 	%endif
@@ -74,5 +76,5 @@
 	%include "Memory.asm"
 	%include "Size.asm"
-	%ifndef EXCLUDE_SORT_UTILS
+	%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 		%include "Sort.asm"
 	%endif
Index: trunk/Assembly_Library/Src/Keyboard/Keyboard.asm
===================================================================
--- trunk/Assembly_Library/Src/Keyboard/Keyboard.asm	(revision 129)
+++ trunk/Assembly_Library/Src/Keyboard/Keyboard.asm	(revision 131)
@@ -20,4 +20,5 @@
 ;		DX
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Keyboard_ReadUserInputtedWordWhilePrinting:
@@ -43,4 +44,5 @@
 	pop		ds
 	ret
+%endif
 
 
@@ -68,4 +70,5 @@
 ;		AX
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Keyboard_ReadUserInputtedStringToESDIWhilePrinting:
@@ -177,4 +180,5 @@
 	xor		al, al								; Set ZF and clear CF
 	ret
+%endif ; EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 
 
@@ -188,4 +192,5 @@
 ;		AX
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Keyboard_PrintBackspace:
@@ -196,4 +201,5 @@
 	mov		al, BS
 	jmp		SHORT Keyboard_PrintInputtedCharacter
+%endif
 
 
@@ -207,8 +213,10 @@
 ;		AX
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Keyboard_PlayBellForUnwantedKeystroke:
 	mov		al, BELL
 	; Fall to Keyboard_PrintInputtedCharacter
+%endif
 
 ;--------------------------------------------------------------------
@@ -221,4 +229,5 @@
 ;		AX
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Keyboard_PrintInputtedCharacter:
@@ -228,4 +237,5 @@
 	pop		di
 	ret
+%endif
 
 
Index: trunk/Assembly_Library/Src/LibSizeCheck.asm
===================================================================
--- trunk/Assembly_Library/Src/LibSizeCheck.asm	(revision 129)
+++ trunk/Assembly_Library/Src/LibSizeCheck.asm	(revision 131)
@@ -13,6 +13,4 @@
 ;%define INCLUDE_UTIL_LIBRARY
 
-%define EXCLUDE_BIT_UTILS
-%define EXCLUDE_SORT_UTILS
 %include "AssemblyLibrary.inc"	; Assembly Library. Must be included first!
 
Index: trunk/Assembly_Library/Src/String/String.asm
===================================================================
--- trunk/Assembly_Library/Src/String/String.asm	(revision 129)
+++ trunk/Assembly_Library/Src/String/String.asm	(revision 131)
@@ -1,7 +1,3 @@
-; File name		:	String.asm
 ; Project name	:	Assembly Library
-; Created date	:	12.7.2010
-; Last update	:	24.10.2010
-; Author		:	Tomi Tilli
 ; Description	:	Functions for handling characters.
 
Index: trunk/Assembly_Library/Src/Time/TimerTicks.asm
===================================================================
--- trunk/Assembly_Library/Src/Time/TimerTicks.asm	(revision 129)
+++ trunk/Assembly_Library/Src/Time/TimerTicks.asm	(revision 131)
@@ -23,6 +23,5 @@
 ;		CX
 ;--------------------------------------------------------------------
-%ifdef INCLUDE_MENU_DIALOGS
-
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 TimerTicks_GetHoursToAXfromTicksInDXAX:
@@ -38,5 +37,4 @@
 	div		cx		; Divide DX:AX by CX, Minutes to AX, remainder ticks to DX
 	ret
-
 %endif
 
@@ -105,4 +103,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 TimerTicks_GetElapsedToAXandResetDSBX:
@@ -112,4 +111,5 @@
 	pop		WORD [bx]			; Latest time to [DS:BX]
 	ret
+%endif
 
 ;--------------------------------------------------------------------
@@ -122,4 +122,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 TimerTicks_GetElapsedToAXfromDSBX:
@@ -127,4 +128,5 @@
 	sub		ax, [bx]
 	ret
+%endif
 
 
Index: trunk/Assembly_Library/Src/Util/Memory.asm
===================================================================
--- trunk/Assembly_Library/Src/Util/Memory.asm	(revision 129)
+++ trunk/Assembly_Library/Src/Util/Memory.asm	(revision 131)
@@ -45,8 +45,10 @@
 ;		Nothing
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Memory_CopyCXbytesFromDSSItoESDI:
 	OPTIMIZE_STRING_OPERATION rep, movs
 	ret
+%endif
 
 
Index: trunk/Assembly_Library/Src/Util/Registers.asm
===================================================================
--- trunk/Assembly_Library/Src/Util/Registers.asm	(revision 129)
+++ trunk/Assembly_Library/Src/Util/Registers.asm	(revision 131)
@@ -42,6 +42,5 @@
 	ret
 
-%ifdef INCLUDE_MENU_DIALOGS
-
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Registers_CopySSBPtoDSSI:
@@ -58,5 +57,4 @@
 	COPY_ESDI_to_DSSI
 	ret
-
 %endif
 