Index: trunk/Assembly_Library/Src/Display/Display.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/Display.asm	(revision 133)
+++ trunk/Assembly_Library/Src/Display/Display.asm	(revision 134)
@@ -81,5 +81,7 @@
 
 	at	DISPLAY_LIB.FormatNullTerminatedStringFromCSSI,				dw	.FormatNullTerminatedStringFromCSSI
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 	at	DISPLAY_LIB.PrintSignedWordFromAXWithBaseInBX,				dw	DisplayPrint_SignedWordFromAXWithBaseInBX
+%endif
 	at	DISPLAY_LIB.PrintWordFromAXwithBaseInBX,					dw	DisplayPrint_WordFromAXWithBaseInBX
 	at	DISPLAY_LIB.PrintCharBufferFromBXSIwithLengthInCX,			dw	DisplayPrint_CharacterBufferFromBXSIwithLengthInCX
@@ -89,5 +91,7 @@
 	at	DISPLAY_LIB.PrintCharacterFromAL,							dw	DisplayPrint_CharacterFromAL
 	at	DISPLAY_LIB.PrintNewlineCharacters,							dw	DisplayPrint_Newline
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 	at	DISPLAY_LIB.ClearAreaWithHeightInAHandWidthInAL,			dw	DisplayPrint_ClearAreaWithHeightInAHandWidthInAL
+%endif
 	at	DISPLAY_LIB.ClearScreenWithCharInALandAttrInAH,				dw	DisplayPrint_ClearScreenWithCharInALandAttributeInAH
 iend
Index: trunk/Assembly_Library/Src/Display/DisplayFormat.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayFormat.asm	(revision 133)
+++ trunk/Assembly_Library/Src/Display/DisplayFormat.asm	(revision 134)
@@ -127,20 +127,34 @@
 
 .rgcFormatCharToLookupIndex:
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 	db		"aAduxsSct-+%"
+%else
+	db		"Auxsc-"		; Required by XTIDE Universal BIOS
+%endif
 .rgcFormatCharToLookupIndexEnd:
 ALIGN WORD_ALIGN
 .rgfnFormatSpecifierParser:
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 	dw		a_FormatAttributeForNextCharacter
+%endif
 	dw		A_FormatAttributeForRemainingString
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 	dw		d_FormatSignedDecimalWord
+%endif
 	dw		u_FormatUnsignedDecimalWord
 	dw		x_FormatHexadecimalWord
 	dw		s_FormatStringFromSegmentCS
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 	dw		S_FormatStringFromFarPointer
+%endif
 	dw		c_FormatCharacter
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 	dw		t_FormatRepeatCharacter
+%endif
 	dw		PrepareToPrependParameterWithSpaces
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 	dw		PrepareToAppendSpacesAfterParameter
 	dw		percent_FormatPercent
+%endif
 
 
@@ -276,4 +290,5 @@
 ;		AX, BX, DX
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 a_FormatAttributeForNextCharacter:
@@ -289,4 +304,5 @@
 	mov		[VIDEO_BDA.displayContext+DISPLAY_CONTEXT.bAttribute], bl
 	ret
+%endif
 
 ALIGN JUMP_ALIGN
@@ -296,4 +312,5 @@
 	ret
 
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 d_FormatSignedDecimalWord:
@@ -301,4 +318,5 @@
 	mov		bx, 10
 	jmp		DisplayPrint_SignedWordFromAXWithBaseInBX
+%endif
 
 ALIGN JUMP_ALIGN
@@ -323,4 +341,5 @@
 	ret
 
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 S_FormatStringFromFarPointer:
@@ -332,4 +351,5 @@
 	dec		bp
 	ret
+%endif
 
 ALIGN JUMP_ALIGN
@@ -338,4 +358,5 @@
 	jmp		DisplayPrint_CharacterFromAL
 
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 t_FormatRepeatCharacter:
@@ -353,4 +374,5 @@
 	mov		al, '%'
 	jmp		DisplayPrint_CharacterFromAL
+%endif
 
 ALIGN JUMP_ALIGN
Index: trunk/Assembly_Library/Src/Display/DisplayPrint.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 133)
+++ trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 134)
@@ -76,4 +76,5 @@
 ;		AX, DX
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 DisplayPrint_SignedWordFromAXWithBaseInBX:
@@ -87,4 +88,5 @@
 	neg		ax
 	; Fall to DisplayPrint_WordFromAXWithBaseInBX
+%endif
 
 ;--------------------------------------------------------------------
@@ -260,4 +262,5 @@
 ;		AX, DX
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 DisplayPrint_ClearAreaWithHeightInAHandWidthInAL:
@@ -288,4 +291,5 @@
 	pop		si
 	ret
+%endif
 
 